Name:          reactive-streams
Version:       1.0.0
Release:       3%{?dist}
Summary:       A Protocol for Asynchronous Non-Blocking Data Sequence
# Source files without license headers https://github.com/reactive-streams/reactive-streams-jvm/issues/333
License:       CC0
URL:           http://www.reactive-streams.org/
Source0:       https://github.com/reactive-streams/reactive-streams-jvm/archive/v%{version}/%{name}-%{version}.tar.gz

BuildRequires: gradle-local
BuildRequires: mvn(org.testng:testng)
BuildArch:     noarch

%description
Reactive Streams is an initiative to provide a standard for
asynchronous stream processing with non-blocking back pressure.
This encompasses efforts aimed at run-time environments (JVM and
JavaScript) as well as network protocols.

%package examples
Summary:       Examples for %{name}

%description examples
This package contains examples for %{name}.

%package tck
Summary:       Reactive Streams TCK

%description tck
The purpose of the Reactive Streams Technology Compatibility Kit
is to guide and help Reactive Streams library implementers to
validate their implementations against the rules defined in the
Specification.

The TCK is implemented using plain Java (1.6) and TestNG tests, and
should be possible to use from other JVM-based languages and
testing libraries.

%package javadoc
Summary:       Javadoc for %{name}

%description javadoc
This package contains javadoc for %{name}.

%prep
%setup -q -n %{name}-jvm-%{version}
# Cleanup
find . -name "*.class" -print -delete
find . -name "*.jar" -print -delete

# Use system libraries
#sed -i 's/mavenCentral()/xmvn()/' build.gradle

# Fix javadoc task
echo "
task javadocAll(type: Javadoc) {
    destinationDir file('javadoc')
    options.encoding = 'UTF-8'
    if (JavaVersion.current().isJava8Compatible()) {
        options.addStringOption('Xdoclint:none', '-quiet')
    }
    source subprojects.collect { project ->
        project.sourceSets.main.allJava
    }
    classpath = files(subprojects.collect { project ->
        project.sourceSets.main.compileClasspath
    })
}" >> build.gradle

# Fix non ASCII chars
for s in api/src/main/java/org/reactivestreams/Processor.java \
 api/src/main/java/org/reactivestreams/Subscription.java \
 tck/src/main/java/org/reactivestreams/tck/IdentityProcessorVerification.java;do
  native2ascii -encoding UTF8 ${s} ${s}
done

# Convert from dos to unix line ending
sed -i.orig 's|\r||g' README.md
touch -r README.md.orig README.md
rm README.md.orig

%build
# Disable test suite: fails on ARM builders
%gradle_build -sf -- javadocAll

%install
%mvn_install -J javadoc

%files -f .mfiles-reactive-streams
%doc README.md RELEASE-NOTES.md
%license COPYING CopyrightWaivers.txt LICENSE

%files examples -f .mfiles-reactive-streams-examples

%files tck -f .mfiles-reactive-streams-tck
%doc tck/README.md

%files javadoc -f .mfiles-javadoc
%license COPYING CopyrightWaivers.txt LICENSE

%changelog
* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Sat Apr 16 2016 gil cattaneo <puntogil@libero.it> 1.0.0-1
- initial rpm
